=== modified file 'django/conf/global_settings.py'
--- django/conf/global_settings.py	2008-02-29 18:38:44 +0000
+++ django/conf/global_settings.py	2008-03-02 09:33:19 +0000
@@ -226,25 +226,25 @@
 
 # Default formatting for date objects. See all available format strings here:
 # http://www.djangoproject.com/documentation/templates/#now
-DATE_FORMAT = 'N j, Y'
+DATE_FORMAT = gettext_noop('N j, Y')
 
 # Default formatting for datetime objects. See all available format strings here:
 # http://www.djangoproject.com/documentation/templates/#now
-DATETIME_FORMAT = 'N j, Y, P'
+DATETIME_FORMAT = gettext_noop('N j, Y, P')
 
 # Default formatting for time objects. See all available format strings here:
 # http://www.djangoproject.com/documentation/templates/#now
-TIME_FORMAT = 'P'
+TIME_FORMAT = gettext_noop('P')
 
 # Default formatting for date objects when only the year and month are relevant.
 # See all available format strings here:
 # http://www.djangoproject.com/documentation/templates/#now
-YEAR_MONTH_FORMAT = 'F Y'
+YEAR_MONTH_FORMAT = gettext_noop('F Y')
 
 # Default formatting for date objects when only the month and day are relevant.
 # See all available format strings here:
 # http://www.djangoproject.com/documentation/templates/#now
-MONTH_DAY_FORMAT = 'F j'
+MONTH_DAY_FORMAT = gettext_noop('F j')
 
 # Do you want to manage transactions manually?
 # Hint: you really don't!

=== modified file 'django/contrib/admin/templatetags/admin_list.py'
--- django/contrib/admin/templatetags/admin_list.py	2007-12-04 19:17:25 +0000
+++ django/contrib/admin/templatetags/admin_list.py	2008-03-02 09:33:19 +0000
@@ -7,7 +7,7 @@
 from django.utils.html import escape, conditional_escape
 from django.utils.text import capfirst
 from django.utils.safestring import mark_safe
-from django.utils.translation import get_date_formats, get_partial_date_formats, ugettext as _
+from django.utils.translation import ugettext as _
 from django.utils.encoding import smart_unicode, smart_str, force_unicode
 from django.template import Library
 import datetime
@@ -161,13 +161,12 @@
             # Dates and times are special: They're formatted in a certain way.
             elif isinstance(f, models.DateField) or isinstance(f, models.TimeField):
                 if field_val:
-                    (date_format, datetime_format, time_format) = get_date_formats()
                     if isinstance(f, models.DateTimeField):
-                        result_repr = capfirst(dateformat.format(field_val, datetime_format))
+                        result_repr = capfirst(dateformat.format(field_val, _(settings.DATETIME_FORMAT)))
                     elif isinstance(f, models.TimeField):
-                        result_repr = capfirst(dateformat.time_format(field_val, time_format))
+                        result_repr = capfirst(dateformat.time_format(field_val, _(settings.TIME_FORMAT)))
                     else:
-                        result_repr = capfirst(dateformat.format(field_val, date_format))
+                        result_repr = capfirst(dateformat.format(field_val, _(settings.DATE_FORMAT)))
                 else:
                     result_repr = EMPTY_CHANGELIST_VALUE
                 row_class = ' class="nowrap"'
@@ -221,7 +220,6 @@
         year_lookup = cl.params.get(year_field)
         month_lookup = cl.params.get(month_field)
         day_lookup = cl.params.get(day_field)
-        year_month_format, month_day_format = get_partial_date_formats()
 
         link = lambda d: mark_safe(cl.get_query_string(d, [field_generic]))
 
@@ -231,9 +229,9 @@
                 'show': True,
                 'back': {
                     'link': link({year_field: year_lookup, month_field: month_lookup}),
-                    'title': dateformat.format(day, year_month_format)
+                    'title': dateformat.format(day, _(settings.YEAR_MONTH_FORMAT))
                 },
-                'choices': [{'title': dateformat.format(day, month_day_format)}]
+                'choices': [{'title': dateformat.format(day, _(settings.MONTH_DAY_FORMAT))}]
             }
         elif year_lookup and month_lookup:
             days = cl.query_set.filter(**{year_field: year_lookup, month_field: month_lookup}).dates(field_name, 'day')
@@ -245,7 +243,7 @@
                 },
                 'choices': [{
                     'link': link({year_field: year_lookup, month_field: month_lookup, day_field: day.day}),
-                    'title': dateformat.format(day, month_day_format)
+                    'title': dateformat.format(day, _(settings.MONTH_DAY_FORMAT))
                 } for day in days]
             }
         elif year_lookup:
@@ -258,7 +256,7 @@
                 },
                 'choices': [{
                     'link': link({year_field: year_lookup, month_field: month.month}),
-                    'title': dateformat.format(month, year_month_format)
+                    'title': dateformat.format(month, _(settings.YEAR_MONTH_FORMAT))
                 } for month in months]
             }
         else:

=== modified file 'django/contrib/databrowse/datastructures.py'
--- django/contrib/databrowse/datastructures.py	2008-02-03 01:52:45 +0000
+++ django/contrib/databrowse/datastructures.py	2008-03-02 09:33:19 +0000
@@ -3,10 +3,11 @@
 convenience functionality and permalink functions for the databrowse app.
 """
 
+from django.conf import settings
 from django.db import models
 from django.utils import dateformat
 from django.utils.text import capfirst
-from django.utils.translation import get_date_formats
+from django.utils.translation import ugettext as _
 from django.utils.encoding import smart_unicode, smart_str, iri_to_uri
 from django.utils.safestring import mark_safe
 from django.db.models.query import QuerySet
@@ -156,13 +157,12 @@
             objs = dict(self.field.choices).get(self.raw_value, EMPTY_VALUE)
         elif isinstance(self.field, models.DateField) or isinstance(self.field, models.TimeField):
             if self.raw_value:
-                date_format, datetime_format, time_format = get_date_formats()
                 if isinstance(self.field, models.DateTimeField):
-                    objs = capfirst(dateformat.format(self.raw_value, datetime_format))
+                    objs = capfirst(dateformat.format(self.raw_value, _(settings.DATETIME_FORMAT)))
                 elif isinstance(self.field, models.TimeField):
-                    objs = capfirst(dateformat.time_format(self.raw_value, time_format))
+                    objs = capfirst(dateformat.time_format(self.raw_value, _(settings.TIME_FORMAT)))
                 else:
-                    objs = capfirst(dateformat.format(self.raw_value, date_format))
+                    objs = capfirst(dateformat.format(self.raw_value, _(settings.DATE_FORMAT)))
             else:
                 objs = EMPTY_VALUE
         elif isinstance(self.field, models.BooleanField) or isinstance(self.field, models.NullBooleanField):

=== modified file 'django/contrib/databrowse/plugins/calendars.py'
--- django/contrib/databrowse/plugins/calendars.py	2008-02-19 00:08:08 +0000
+++ django/contrib/databrowse/plugins/calendars.py	2008-03-02 09:33:19 +0000
@@ -4,7 +4,6 @@
 from django.contrib.databrowse.sites import DatabrowsePlugin
 from django.shortcuts import render_to_response
 from django.utils.text import capfirst
-from django.utils.translation import get_date_formats
 from django.utils.encoding import force_unicode
 from django.utils.safestring import mark_safe
 from django.views.generic import date_based

=== modified file 'django/template/defaultfilters.py'
--- django/template/defaultfilters.py	2008-02-25 06:02:35 +0000
+++ django/template/defaultfilters.py	2008-03-02 09:33:33 +0000
@@ -620,7 +620,7 @@
     if not value:
         return u''
     if arg is None:
-        arg = settings.DATE_FORMAT
+        arg = ugettext(settings.DATE_FORMAT)
     return format(value, arg)
 date.is_safe = False
 
@@ -630,7 +630,7 @@
     if value in (None, u''):
         return u''
     if arg is None:
-        arg = settings.TIME_FORMAT
+        arg = ugettext(settings.TIME_FORMAT)
     return time_format(value, arg)
 time.is_safe = False
 