diff --git a/django/views/generic/create_update.py b/django/views/generic/create_update.py
index 46e92fe..ab8b9fb 100644
--- a/django/views/generic/create_update.py
+++ b/django/views/generic/create_update.py
@@ -7,6 +7,188 @@ from django.template import RequestContext
 from django.http import Http404, HttpResponse, HttpResponseRedirect
 from django.core.exceptions import ObjectDoesNotExist, ImproperlyConfigured
 from django.utils.translation import ugettext
+from django import newforms as forms
+from django.newforms.models import ModelFormMetaclass, ModelForm
+
+
+# New-sytle, class based generic views #######################################
+
+class BaseView(object):
+    """
+    Base class for generic object creation and update view.
+
+    Templates: ``<app_label>/<model_name>_form.html``
+    Context:
+        form
+            the ``ModelForm`` instance for the object
+    """
+    def __init__(self, model, post_save_redirect=None):
+        self.model = model
+        self.post_save_redirect = None
+
+    def __call__(self, request):
+        return self.main(request, self.get_instance(request))
+
+    def main(self, request, instance):
+        Form = self.get_form(request)
+        if request.POST:
+            form = Form(request.POST, request.FILES, instance=instance)
+            if form.is_valid():
+                new_object = self.save(request, form)
+                return self.post_save(request, new_object)
+        else:
+            form = Form()
+
+        t = self.get_template(request)
+        c = self.get_context(request, form, instance)
+        return HttpResponse(t.render(c))
+
+    def get_form(self, request):
+        """
+        Returns a ``ModelForm`` class to be used in this view.
+        """
+        # TODO: we should be able to construct a ModelForm without creating
+        # and passing in a temporary inner class
+        class Meta:
+            model = self.model
+        class_name = self.model.__name__ + 'Form'
+        return ModelFormMetaclass(class_name, (ModelForm,), {'Meta': Meta})
+
+    def get_template(self, request):
+        """
+        Returns the template to be used when rendering this view. Those who
+        wish to use a custom template loader should do so here.
+        """
+        opts = self.model._meta
+        template_name = "%s/%s_form.html" % (opts.app_label, opts.object_name.lower())
+        return loader.get_template(template_name)
+
+    def get_context(self, request, form, instance):
+        """
+        Returns a ``Context`` instance to be used when rendering this view.
+        """
+        return RequestContext(request, {'form': form, 'object': instance})
+
+    def save(self, request, form):
+        """
+        Saves the object represented by the given ``form``. This method will
+        only be called if the form is valid, and should in most cases return
+        an HttpResponseRediect. It's return value will be the return value
+        for the view on success.
+        """
+        return form.save()
+
+    def post_save(self, request, new_object):
+        """
+        Returns
+        """
+        if request.user.is_authenticated():
+            message = self.get_message(request, new_object)
+            request.user.message_set.create(message=message)
+        # Redirect to the new object: first by trying post_save_redirect,
+        # then by obj.get_absolute_url; fail if neither works.
+        if self.post_save_redirect:
+            return HttpResponseRedirect(post_save_redirect % new_object.__dict__)
+        elif hasattr(new_object, 'get_absolute_url'):
+            return HttpResponseRedirect(new_object.get_absolute_url())
+        else:
+            raise ImproperlyConfigured("No URL to redirect to from generic create view.")
+
+class AddView(BaseView):
+    def get_instance(self, request):
+        """
+        Returns the object instance to create.
+        """
+        return self.model()
+
+    def get_message(self, request, new_object):
+        return ugettext("The %(verbose_name)s was created successfully.") % {"verbose_name": self.model._meta.verbose_name}
+
+class ChangeView(BaseView):
+    def __init__(self, model, post_save_redirect=None, slug_field='slug'):
+        self.slug_field = slug_field
+        super(ChangeView, self).__init__(model, post_save_redirect=post_save_redirect)
+
+    def __call__(self, request, object_id=None, slug=None):
+        return self.main(request, self.get_instance(request, object_id, slug))
+
+    def get_query_set(self, request):
+        """
+        Returns a queryset to use when trying to look up the object to change.
+        """
+        return self.model._default_manager.get_query_set()
+
+    def get_instance(self, request, object_id=None, slug=None):
+        """
+        Returns the object to be changed, or raises a 404 if it doesn't exist.
+        """
+        # Look up the object to be edited
+        lookup_kwargs = {}
+        if object_id:
+            lookup_kwargs['pk'] = object_id
+        elif slug and self.slug_field:
+            lookup_kwargs['%s__exact' % slug_field] = slug
+        else:
+            raise AttributeError("Generic view must be called with either an object_id or a slug/slug_field")
+        try:
+            return self.get_query_set(request).get(**lookup_kwargs)
+        except ObjectDoesNotExist:
+            raise Http404, "No %s found for %s" % (self.model._meta.verbose_name, lookup_kwargs)
+
+    def get_message(self, request, new_object):
+        return ugettext("The %(verbose_name)s was updated successfully.") % {"verbose_name": self.model._meta.verbose_name}
+
+class DeleteView(ChangeView):
+    def __init__(self, model, post_save_redirect=None, slug_field='slug'):
+        self.model = model
+        self.slug_field = slug_field
+        self.post_save_redirect = post_save_redirect
+
+    def main(self, request, instance):
+        if request.method == 'POST':
+            self.delete(instance)
+            return self.post_save(request, instance)
+        t = self.get_template(request)
+        c = self.get_context(request, instance)
+        response = HttpResponse(t.render(c))
+        populate_xheaders(request, response, self.model, instance.pk)
+        return response
+
+    def get_context(self, request, instance):
+        """
+        Returns a ``Context`` instance to be used when rendering this view.
+        """
+        return RequestContext(request, {'object': instance})
+
+    def get_template(self, request):
+        opts = self.model._meta
+        template_name = "%s/%s_confirm_delete.html" % (opts.app_label, opts.object_name.lower())
+        return loader.get_template(template_name)
+
+    def delete(request, instance):
+        """
+        Deletes the given instance. Subclasses that wish to veto deletion
+        should do so here.
+        """
+        instance.delete()
+
+    def post_save(self, request, new_object):
+        """
+        Redirects to self.post_save_redirect after setting a message if the
+        user is logged in.
+        
+        This method is only called if saving the object was successful.
+        """
+        if request.user.is_authenticated():
+            message = self.get_message(request, new_object)
+            request.user.message_set.create(message=message)
+        return HttpResponseRedirect(self.post_save_redirect)
+
+    def get_message(self, request, new_object):
+        return ugettext("The %(verbose_name)s was deleted.") % {"verbose_name": model._meta.verbose_name}
+
+
+# Classic generic views ######################################################
 
 def create_object(request, model, template_name=None,
         template_loader=loader, extra_context=None, post_save_redirect=None,
diff --git a/tests/regressiontests/views/tests/__init__.py b/tests/regressiontests/views/tests/__init__.py
index 2c8c5b4..f0f6f59 100644
--- a/tests/regressiontests/views/tests/__init__.py
+++ b/tests/regressiontests/views/tests/__init__.py
@@ -1,4 +1,5 @@
 from defaults import *
 from i18n import *
 from static import *
+from generic.create_update import *
 from generic.date_based import *
\ No newline at end of file
diff --git a/tests/regressiontests/views/tests/generic/create_update.py b/tests/regressiontests/views/tests/generic/create_update.py
new file mode 100644
index 0000000..7cdbb9e
--- /dev/null
+++ b/tests/regressiontests/views/tests/generic/create_update.py
@@ -0,0 +1,44 @@
+# coding: utf-8 
+from django.test import TestCase 
+from regressiontests.views.models import Article, Author
+
+class AddViewTest(TestCase):
+
+    def test_initial(self):
+        response = self.client.get('/views/create_update/add/')
+        self.assertEqual(response.status_code, 200) 
+        self.assertEqual(response.context['form']._meta.model, Author)
+        self.assertEqual(response.context['object'].name, "")
+
+    def test_submit(self):
+        response = self.client.post('/views/create_update/add/', {
+            'name': 'Boris',
+        })
+        self.assertEqual(response.status_code, 302)
+
+class ChangeViewTest(TestCase):
+    fixtures = ['testdata.json']
+
+    def test_initial(self):
+        response = self.client.get('/views/create_update/1/change/')
+        self.assertEqual(response.status_code, 200) 
+        self.assertEqual(response.context['form']._meta.model, Author)
+        self.assertEqual(response.context['object'].name, "Boris")
+
+    def test_submit(self):
+        response = self.client.post('/views/create_update/1/change/', {
+            'name': 'Jack Kerouac',
+        })
+        self.assertEqual(response.status_code, 302)
+
+class DeleteViewTest(TestCase):
+    fixtures = ['testdata.json']
+
+    def test_initial(self):
+        response = self.client.get('/views/create_update/1/delete/')
+        self.assertEqual(response.status_code, 200) 
+        self.assertEqual(response.context['object'].name, "Boris")
+
+    def test_submit(self):
+        response = self.client.post('/views/create_update/1/delete/', {})
+        self.assertEqual(response.status_code, 302)
diff --git a/tests/regressiontests/views/urls.py b/tests/regressiontests/views/urls.py
index 5ef0c51..ebd5721 100644
--- a/tests/regressiontests/views/urls.py
+++ b/tests/regressiontests/views/urls.py
@@ -1,6 +1,7 @@
 from os import path
 
 from django.conf.urls.defaults import *
+from django.views.generic.create_update import AddView, ChangeView, DeleteView
 
 from models import *
 import views
@@ -9,6 +10,10 @@ base_dir = path.dirname(path.abspath(__file__))
 media_dir = path.join(base_dir, 'media')
 locale_dir = path.join(base_dir, 'locale')
 
+author_add = AddView(Author)
+author_change = ChangeView(Author)
+author_delete = DeleteView(Author)
+
 js_info_dict = {
     'domain': 'djangojs',
     'packages': ('regressiontests.views',),
@@ -34,8 +39,14 @@ urlpatterns = patterns('',
     
     # Static views
     (r'^site_media/(?P<path>.*)$', 'django.views.static.serve', {'document_root': media_dir}),
-    
-	# Date-based generic views
+
+    # Create/Update generic views
+    (r'create_update/add/', author_add),
+    (r'create_update/(?P<object_id>\d+)/change/', author_change),
+    (r'create_update/(?P<object_id>\d+)/delete/', author_delete),
+
+
+    # Date-based generic views
     (r'^date_based/object_detail/(?P<year>\d{4})/(?P<month>\d{1,2})/(?P<day>\d{1,2})/(?P<slug>[-\w]+)/$', 
         'django.views.generic.date_based.object_detail', 
         dict(slug_field='slug', **date_based_info_dict)), 
diff --git a/tests/templates/views/author_confirm_delete.html b/tests/templates/views/author_confirm_delete.html
new file mode 100644
index 0000000..3f8ff55
--- /dev/null
+++ b/tests/templates/views/author_confirm_delete.html
@@ -0,0 +1 @@
+This template intentionally left blank
\ No newline at end of file
diff --git a/tests/templates/views/author_form.html b/tests/templates/views/author_form.html
new file mode 100644
index 0000000..3f8ff55
--- /dev/null
+++ b/tests/templates/views/author_form.html
@@ -0,0 +1 @@
+This template intentionally left blank
\ No newline at end of file