Index: docs/index.txt
===================================================================
--- docs/index.txt	(revision 11739)
+++ docs/index.txt	(working copy)
@@ -152,6 +152,9 @@
       :ref:`Apache authentication <howto-apache-auth>` |
       :ref:`Serving static files <howto-static-files>` |
       :ref:`Tracking code errors by e-mail <howto-error-reporting>`
+  
+    * **Exceptions:**
+      :ref:`Overview <ref-exceptions>`
 
 Other batteries included
 ========================
Index: docs/ref/models/querysets.txt
===================================================================
--- docs/ref/models/querysets.txt	(revision 11739)
+++ docs/ref/models/querysets.txt	(working copy)
@@ -884,11 +906,11 @@
 These methods do not use a cache (see :ref:`caching-and-querysets`). Rather,
 they query the database each time they're called.
 
-.. _get-kwargs:
-
 ``get(**kwargs)``
 ~~~~~~~~~~~~~~~~~
 
+.. method:: QuerySet.get(**kwargs)
+
 Returns the object matching the given lookup parameters, which should be in
 the format described in `Field lookups`_.
 
Index: docs/ref/exceptions.txt
===================================================================
--- docs/ref/exceptions.txt	(revision 0)
+++ docs/ref/exceptions.txt	(revision 0)
@@ -0,0 +1,88 @@
+.. _ref-exceptions:
+
+=================
+Django Exceptions
+=================
+
+This document describes the exceptions raised by Django.
+
+Django raises some Django specific exceptions as well as many standard Python
+exceptions.
+
+Django Specific Exceptions
+==========================
+
+.. module:: django.core.exceptions
+    :synopsis: Django specific exceptions
+
+Most of the Django specific exceptions are in the ``django.core.exceptions``
+module. For example, ``django.core.exceptions.ViewDoesNotExist``.
+
+ObjectDoesNotExist and DoesNotExist
+-----------------------------------
+The ``DoesNotExist`` exception is raised when an object is not found for the
+given parameters of a query.  The ``DoesNotExist`` exception is not in ``django.core.exceptions``.  Instead, it is an attribute of the model class and
+inherits from ``ObjectDoesNotExist`` which is in ``django.core.exceptions``.
+See :meth:`~django.db.models.QuerySet.get()` for further information on 
+``ObjectDoesNotExist`` and ``DoesNotExist``.
+
+MultipleObjectsReturned
+-----------------------
+The ``MultipleObjectsReturned`` exception is raised by a query if only one
+object is expected, but multiple objects are returned.  See 
+:meth:`~django.db.models.QuerySet.get()` for further information.  The ``MultipleObjectsReturned`` exception is an attribute of a
+model class and it is in ``django.core.exceptions``.
+
+SuspiciousOperation
+-------------------
+The ``SuspiciousOperation`` exception is raised when a user did something
+suspicious.
+
+PermissionDenied
+----------------
+The ``PermissionDenied`` exception is raised when a user does not have
+permission to perform the action attempted.
+
+ViewDoesNotExist
+----------------
+The ``ViewDoesNotExist`` exception is raised by ``django.core.urlresolvers``
+when a requested view does not exist.
+
+MiddlewareNotUsed
+-----------------
+The ``MiddlewareNotUsed`` exception is raised when a middleware is not used in
+the server configuration.
+
+ImproperlyConfigured
+--------------------
+The ``ImproperlyConfigured`` exception is raised when Django is somehow
+improperly configured. 
+
+FieldError
+----------
+The ``FieldError`` exception is raised when there is a problem with a model
+field.  This can happen for several reasons, some of which are:
+    
+    - A field in a model clashes with a field of the same name from an abstract base class
+    - An infinite loop is caused by ordering
+    - A keyword cannot be parsed from the filter parameters
+    - If a field cannot be determined from a keyword in the query parameters
+    - If a join is not permitted on the specified field
+    - If a field name is invalid
+    - If a query contains invalid order_by arguments
+
+Database Exceptions
+===================
+Django raises or propagates standard database exceptions, such as 
+``DatabaseError`` and ``IntegrityError``, when appropriate for operations on
+model objects.  See  `PEP 249 - Python Database API Specification v2.0`_ for
+further information about database exceptions.
+
+.. _`PEP 249 - Python Database API Specification v2.0`: http://www.python.org/dev/peps/pep-0249/
+
+Python Exceptions
+=================
+Django raises built-in Python exceptions when appropriate as well. See the
+Python `documentation`_ for further information on the built-in exceptions. 
+
+.. _`documentation`: http://docs.python.org/lib/module-exceptions.html

Property changes on: docs/ref/exceptions.txt
___________________________________________________________________
Added: svn:executable
   + *

Index: docs/ref/contrib/contenttypes.txt
===================================================================
--- docs/ref/contrib/contenttypes.txt	(revision 11739)
+++ docs/ref/contrib/contenttypes.txt	(working copy)
@@ -114,8 +114,8 @@
 
     Takes a set of valid :ref:`lookup arguments <field-lookups-intro>` for the
     model the :class:`~django.contrib.contenttypes.models.ContentType`
-    represents, and does :ref:`a get() lookup <get-kwargs>` on that model,
-    returning the corresponding object.
+    represents, and does a :meth:`~django.db.models.QuerySet.get()` lookup on
+    that model, returning the corresponding object.
 
 .. method:: models.ContentType.model_class()
 